select
   an.numero as numero
  , (case when (an.sexo = 'M') then 1 else 2 end) as sexo
  , an.seriealfa as serie
  , cast(an.rgn as varchar(16)) as rgn
  , cast(an.regassocraca as varchar(16)) as rgd
  , lpad(extract(day from pe.dtpeso),2,0) || '/' || lpad(extract(month from pe.dtpeso),2,0) || '/' || extract(year from pe.dtpeso) as data_medida
  , cast(pe.peso as integer) as peso
from
  associacao ass
  join animal an on 1 = 1
  left join graucruzamento gc on gc.cdgraucruzamento = an.cdgraucruzamento
  join sp_retornaracaancp(an.cdanimal) rac on 1 = 1 and rac.codigoraca <> ''
  join peso pe on pe.cdanimal = an.cdanimal
  left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = pe.cdanimal and re.cdtipogrupoanimal = (select valor from configuracao where nome = 'TipoGrupoPrincipal')
            and re.dtmovimentacao <= pe.dtpeso order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
  join setor se on se.cdsetor = an.cdsetor
  left join medida med on med.cdanimal = pe.cdanimal and med.dtmedida = pe.dtpeso and med.cdtipomedida in
    (select tm.cdtipomedida from tipomedida tm where upper(tm.descricao) like '%ESCROT%')
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  --Busca da nfa no cadastro da associacao
  and ass.numero = 100
  --Filtro de sexo
  and an.sexo in ('F', 'M')
  --Filtro de setor - NMERO - preencher com o numero do setor
  and se.numero in ('1', '2', '3', '4', '5')
  --Perodo de pesagem no formato AAAA-MM-DD
  and pe.dtpeso between '2017-01-01' and '2017-08-31'
  -- Animais sem regime alimentar
  and g1.cdregimealimentar is null
