select
   cast(lpad(ass.codigoproprietario, 4, '0') as varchar(4)) as nfa
   , rac.codigoraca as raca
   , (case when
            --100% Mocha
            (an.cdanimal = any (select cdanimal from animalraca where cdanimal = an.cdanimal and
                            (cdraca = 305 and percentual = 100) or
                            (cdraca = 450 and percentual = 100) or
                            (cdraca = 290 and percentual = 100)))
            then
              'M'
            else 'P' end) as variedade
  , gc.sigla as categoria
  , (case when (an.sexo = 'M') then 1 else 2 end) as sexo
  , cast((extract (year from an.dtnascimento)) as varchar(4)) as anonascto
  , an.seriealfa as serie
  , cast(an.rgn as varchar(16)) as rgn
  , cast(an.regassocraca as varchar(16)) as rgd
  , 'BR' as iorreg
  , lpad(extract(day from pe.dtpeso),2,0) || '/' || lpad(extract(month from pe.dtpeso),2,0) || '/' || extract(year from pe.dtpeso) as data_medida
  , cast(pe.peso as integer) as peso
  , (CASE WHEN (med.valor IS NOT null) THEN 
  		(CAST((SELECT otexto FROM sp_strreplace(med.valor, ',', '.')) AS decimal(15,3))*10)
  		ELSE NULL end) AS pe_mm
  , (case when ((an.dtbaixa is not null) and (an.cdtipobaixa = 3)) then '2'
            when ((an.dtbaixa is not null) and (an.cdtipobaixa in (1,2))) then '4'
            when ((an.dtbaixa is null) and (pe.dtpeso = an.dtdesmama)) then '6'
            when ((an.dtbaixa is null) and (exists (select * from reproducao re where re.cdanimal = pe.cdanimal and re.cdtiporeproducao = 7
                                                    and re.data = pe.dtpeso))) then 8
            else 0 end) as situacao
  , g1.cdregimealimentar as manejo
  , g1.cdgrupoanimal as lotemanejo
  , cast(lpad(ass.codigoproprietario, 4, '0') as varchar(4)) as nfm
from
  associacao ass
  join animal an on 1 = 1
  left join graucruzamento gc on gc.cdgraucruzamento = an.cdgraucruzamento
  join sp_retornaracaancp(an.cdanimal) rac on 1 = 1 and rac.codigoraca <> ''
  join peso pe on pe.cdanimal = an.cdanimal
  left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = pe.cdanimal and re.cdtipogrupoanimal = (select valor from configuracao where nome = 'TipoGrupoPrincipal')
            and re.dtmovimentacao <= pe.dtpeso order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
  join setor se on se.cdsetor = an.cdsetor
  left join medida med on med.cdanimal = pe.cdanimal and med.dtmedida = pe.dtpeso and med.cdtipomedida in
    (select tm.cdtipomedida from tipomedida tm where upper(tm.descricao) like '%ESCROT%')
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  --Busca da nfa no cadastro da associacao
  and ass.numero = 100
  --Filtro de sexo
  and an.sexo in ('F', 'M')
  --Filtro de setor - NMERO - preencher com o numero do setor
  and se.numero in ('1', '2', '3', '4', '5')
  --Perodo de pesagem no formato AAAA-MM-DD
  and pe.dtpeso between '2017-01-01' and '2017-08-31'
  -- Tirar animais sem regime alimentar (solicitao do Danilo no fim de 2019)
  and g1.cdregimealimentar is not null
